com.jnape.palatable.lambda.functions.builtin.fn2

## Class Peek2<A,B,FAB extends BoundedBifunctor<A,B,? super A,? super B,?>>

- java.lang.Object
- - com.jnape.palatable.lambda.functions.builtin.fn2.Peek2<A,B,FAB>

- Type Parameters:
    `A` - the bifunctor's first parameter type
    `B` - the bifunctor's second parameter type
    `FAB` - the bifunctor type
  All Implemented Interfaces:
    Fn1<Fn1<? super A,? extends IO<?>>,Fn1<Fn1<? super B,? extends IO<?>>,Fn1<FAB,FAB>>>, Fn2<Fn1<? super A,? extends IO<?>>,Fn1<? super B,? extends IO<?>>,Fn1<FAB,FAB>>, Fn3<Fn1<? super A,? extends IO<?>>,Fn1<? super B,? extends IO<?>>,FAB,FAB>, Applicative<Fn1<Fn1<? super B,? extends IO<?>>,Fn1<FAB,FAB>>,Fn1<Fn1<? super A,? extends IO<?>>,?>>, Cartesian<Fn1<? super A,? extends IO<?>>,Fn1<Fn1<? super B,? extends IO<?>>,Fn1<FAB,FAB>>,Fn1<?,?>>, Cocartesian<Fn1<? super A,? extends IO<?>>,Fn1<Fn1<? super B,? extends IO<?>>,Fn1<FAB,FAB>>,Fn1<?,?>>, Contravariant<Fn1<? super A,? extends IO<?>>,Profunctor<?,Fn1<Fn1<? super B,? extends IO<?>>,Fn1<FAB,FAB>>,Fn1<?,?>>>, Functor<Fn1<Fn1<? super B,? extends IO<?>>,Fn1<FAB,FAB>>,Fn1<Fn1<? super A,? extends IO<?>>,?>>, Profunctor<Fn1<? super A,? extends IO<?>>,Fn1<Fn1<? super B,? extends IO<?>>,Fn1<FAB,FAB>>,Fn1<?,?>>, Monad<Fn1<Fn1<? super B,? extends IO<?>>,Fn1<FAB,FAB>>,Fn1<Fn1<? super A,? extends IO<?>>,?>>, MonadReader<Fn1<? super A,? extends IO<?>>,Fn1<Fn1<? super B,? extends IO<?>>,Fn1<FAB,FAB>>,Fn1<Fn1<? super A,? extends IO<?>>,?>>, MonadRec<Fn1<Fn1<? super B,? extends IO<?>>,Fn1<FAB,FAB>>,Fn1<Fn1<? super A,? extends IO<?>>,?>>, MonadWriter<Fn1<? super A,? extends IO<?>>,Fn1<Fn1<? super B,? extends IO<?>>,Fn1<FAB,FAB>>,Fn1<Fn1<? super A,? extends IO<?>>,?>>

  Deprecated.
  in favor of producing an `IO` from the given `BoundedBifunctor` and explicitly running it

      @Deprecated
      public final class Peek2<A,B,FAB extends BoundedBifunctor<A,B,? super A,? super B,?>>
      extends Object
      implements Fn3<Fn1<? super A,? extends IO<?>>,Fn1<? super B,? extends IO<?>>,FAB,FAB>

  Given two `Effect`s, "peek" at the values contained inside a `Bifunctor` via `BoundedBifunctor.biMap(Fn1, Fn1)`, applying the `Effect`s to the contained values, if there are any.

- - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `FAB` | `checkedApply(Fn1<? super A,? extends IO<?>> effectA, Fn1<? super B,? extends IO<?>> effectB, FAB fab)` Deprecated.
    `static <A,B,FAB extends BoundedBifunctor<A,B,? super A,? super B,?>> Peek2<A,B,FAB>` | `peek2()` Deprecated.
    `static <A,B,FAB extends BoundedBifunctor<A,B,? super A,? super B,?>> Fn2<Fn1<? super B,? extends IO<?>>,FAB,FAB>` | `peek2(Fn1<? super A,? extends IO<?>> effectA)` Deprecated.
    `static <A,B,FAB extends BoundedBifunctor<A,B,? super A,? super B,?>> Fn1<FAB,FAB>` | `peek2(Fn1<? super A,? extends IO<?>> effectA, Fn1<? super B,? extends IO<?>> effectB)` Deprecated.
    `static <A,B,FAB extends BoundedBifunctor<A,B,? super A,? super B,?>> FAB` | `peek2(Fn1<? super A,? extends IO<?>> effectA, Fn1<? super B,? extends IO<?>> effectB, FAB fab)` Deprecated.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functions.Fn3

      `apply, apply, apply, checkedApply, compose, contraMap, diMapL, discardR, flip, fn3, fn3, fn3, uncurry, widen`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functions.Fn2

      `checkedApply, curried, curry, fn2, fromBiFunction, toBiFunction`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functions.Fn1

      `andThen, carry, cartesian, censor, choose, cocartesian, diMap, diMapR, discardL, flatMap, fmap, fn1, fromFunction, lazyZip, listens, local, pure, pureFn1, thunk, toFunction, trampolineM, zip, zip`

    - ### Methods inherited from interface com.jnape.palatable.lambda.monad.Monad

      `join`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functor.Functor

      `coerce`

- - ### Method Detail

    - #### checkedApply

          public FAB checkedApply(Fn1<? super A,? extends IO<?>> effectA,
                                  Fn1<? super B,? extends IO<?>> effectB,
                                  FAB fab)

      Deprecated.
      Specified by:
        `checkedApply` in interface `Fn3<Fn1<? super A,? extends IO<?>>,Fn1<? super B,? extends IO<?>>,FAB extends BoundedBifunctor<A,B,? super A,? super B,?>,FAB extends BoundedBifunctor<A,B,? super A,? super B,?>>`

    - #### peek2

          public static <A,B,FAB extends BoundedBifunctor<A,B,? super A,? super B,?>> Peek2<A,B,FAB> peek2()

      Deprecated.

    - #### peek2

          public static <A,B,FAB extends BoundedBifunctor<A,B,? super A,? super B,?>> Fn2<Fn1<? super B,? extends IO<?>>,FAB,FAB> peek2(Fn1<? super A,? extends IO<?>> effectA)

      Deprecated.

    - #### peek2

          public static <A,B,FAB extends BoundedBifunctor<A,B,? super A,? super B,?>> Fn1<FAB,FAB> peek2(Fn1<? super A,? extends IO<?>> effectA,
                                                                                                         Fn1<? super B,? extends IO<?>> effectB)

      Deprecated.

    - #### peek2

          public static <A,B,FAB extends BoundedBifunctor<A,B,? super A,? super B,?>> FAB peek2(Fn1<? super A,? extends IO<?>> effectA,
                                                                                                Fn1<? super B,? extends IO<?>> effectB,
                                                                                                FAB fab)

      Deprecated.